
	box = {}
	box.x = 20
	box.y = 20
	box.x_vel = 0
	box.y_vel = 0
	box.speed = 100
	box.speed_norm = 100/math.sqrt(2)

function box_draw()

	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("fill", box.x, box.y, 32, 32)

end

function box_update(dt)
    box.left=love.keyboard.isDown("a")
    box.right=love.keyboard.isDown("d")
    box.up=love.keyboard.isDown("w")
    box.down=love.keyboard.isDown("s")

    -- normalize diagonal movement
    if (box.left and box.up) or (box.left and box.down) or (box.right and box.up) or (box.right and box.down) then speed=box.speed_norm
    else speed=box.speed end

	if box.left then
        local _x=box.x - speed * dt
        if not box_checkCollision(_x,box.y) then box.x = _x end
	end 
	if box.right then
        local _x=box.x + speed * dt
        if not box_checkCollision(_x,box.y) then box.x = _x end
 	end 
 	if box.up then
        local _y=box.y - speed * dt
        if not box_checkCollision(box.x,_y) then box.y = _y end
 	end 
 	if box.down then
        local _y=box.y + speed * dt
        if not box_checkCollision(box.x,_y) then box.y = _y end
 	end
end

function box_checkCollision(x,y)
    local col=false

    for grid_y,v in ipairs(tiletable) do
        for grid_x,tile in ipairs(v) do
            if tile==3 and x+tileW>(grid_x-1)*tileW and y+tileH>(grid_y-1)*tileH and x<(grid_x-1)*tileW+tileW and y<(grid_y-1)*tileH+tileH then col=true end
        end
    end

    return col
end
